/* Problem URL: https://codeforces.com/contest/2146/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vi fds(n);
        cin >> fds;

        int prev = n;
        n++;
        fds.push_back(0);
        
        while (__builtin_popcount(n) != 1) {
            n++;
            fds.push_back(0);
        }
        
        vvi segm(n * 2);

        function<void(int, int, int)> build = [&](int i, int l, int r) {
            if (l == r) {
                segm[i] = {fds[i - n]};
                return;
            }

            int mid = (l + r) >> 1;

            build(i * 2, l, mid);
            build(i * 2 + 1, mid + 1, r);

            merge(all(segm[i * 2]), all(segm[i * 2 + 1]), back_inserter(segm[i]));
        };

        build(1, 0, n - 1);

        function<int(int, int, int, int, int, int)> querym = [&](int i, int l, int r, int tl, int tr, int v) {
            if (l > tr || r < tl) {
                return 0;
            }

            if (l >= tl && r <= tr) {
                auto upper = upper_bound(all(segm[i]), v);
                return (int)(segm[i].end() - upper);
            }

            int mid = (l + r) >> 1;

            return querym(i * 2, l, mid, tl, tr, v) + querym(i * 2 + 1, mid + 1, r, tl, tr, v);
        };

        vi seg(n * 2, -1);

        auto update = [&](int i, int v) {
            i += n;
            seg[i] = v;

            for (i >>= 1; i > 0; i >>= 1) {
                seg[i] = min(seg[i * 2], seg[i * 2 + 1]);
            }
        };
        
        function<int(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) {
            int oo = INT32_MAX >> 1;
            if (l > tr || r < tl) {
                return oo;
            }

            if (l >= tl && r <= tr) {
                return seg[i];
            }

            int mid = (l + r) >> 1;

            return min(query(i * 2, l, mid, tl, tr), query(i * 2 + 1, mid + 1, r, tl, tr));
        };

        vi ans(prev);
        rep(i, prev) {
            update(fds[i], i);

            int mex = 0;
            int ans = 0;

            while (mex <= n) {
                int minimal = query(1, 0, n - 1, 0, mex);

                int tmp = querym(1, 0 , n - 1, minimal, i, mex);

                if (tmp >= ans) {
                    ans = tmp;
                    mex++;
                    continue;
                }

                break;
            }

            cout << ans << " \n"[i == prev - 1];
        }
    }
}
